/**
* @file
*/

// example function
// (function ($, Drupal) {
// Drupal.AjaxCommands.prototype.fetch = function (ajax, response, status) {
//   console.log(response.message);
// }

// })(jQuery, Drupal);




Drupal.behaviors.doi = {
  attach: (function ($, context, settings) {
    // var userCite = $("#edit-field-ercore-pb-full-citation-0-value").val(); //TODO dont need this particularly
    $(document).ready(function(){
      console.log("TESTTEST")
      if ($('#edit-field-previous-federal-repo--wrapper > legend').length){
        
        $( "#edit-field-previous-federal-repo--wrapper > legend" ).append( $( '<span class="tooltip"><div class=" tooltip-style">?<div class="tooltiptext tooltiptext2"><div>The National Science Foundation (NSF) has developed interoperability with another Federal agency, the Department of Energy, Office of Scientific and Technical Information (DOE/OSTI) in order to allow authors of publications funded by both agencies (NSF and DOE) to deposit the findal accepted version fo their manuscript one time. Authors who have successfully deposited and eligible publication in DOE/OSTI’s system will now be able to seamlessly make their publication available through NSF-PAR by choosing “Yes” and selecting the appropriate entry for the federal repository from the drop-down.</div><br><div>If you have deposited a publication in the DOE system but you’re not able to successfully upload using the option provided, indicate “No”</div></div></div><span style="margin-left: 4px; font-size: 7pt; font-weight: 500;">More Info</span></span>' ) );
        $( "#edit-field-federal-repository-wrapper > div " ).append( $( '<span class="tooltip"><div class=" tooltip-style">?<div class="tooltiptext tooltiptext2"> Currently, the NSF-PAR system only supports the Department of Energy (DOE) federal repository. If you have deposited your publication in a repository other than DOE, please select the “No” option above. </div></div><span style="margin-left: 4px; font-size: 7pt;">What if the Federal Repository is not listed here?</span></span>' ) );

      }
      $("#edit-field-doi-json-wrapper").hide();
      if($("#edit-field-ercore-pb-doi-0-value").val() != "" && $("#edit-field-doi-json-0-value").val() == ""){
        $.ajax({
          url: "https://dx.doi.org/" + $("#edit-field-ercore-pb-doi-0-value").val(), dataType: "json",
          success: function (response) {
            $("#edit-field-doi-json-0-value").val(JSON.stringify(response));
            console.log($("#edit-field-doi-json-0-value").val());
          }
        })
      }
    });
    // Attach a click listener to the edit button.
    var clearBtn = document.getElementById('edit-button');
    var doiResponse = null;
    var doi_data = null; 
    clearBtn.addEventListener('click', function () {

      
      
      console.log("NEW CHANGES ")
      // Do something!
      doi = $("#edit-doitext").val();
      typeMap = {
        "article-journal": "Journal Article",
        "journal-article": "Journal Article",
        "book": "Book",
        "paper-conference": "Conference Proceedings",
        "article-magazine": "Magazine Article",
        "report": "Technical Report",
        "article-newspaper": "Newspaper Article",
        'JournalArticle': 'Journal Article',
        'Journal': 'Journal Article',
        'Preprint': 'Journal Article',
        'Article': 'Journal Article',
        'Book': 'Book',
        'BookChapter': 'Book',
        'ConferencePaper': 'Conference Proceedings',
        'ConferenceProceeding': 'Conference Proceedings',
        'Report': "Technical Report"
      }

      // Registry Agent Mappings 
      let ra_map = {
        'Crossref': {
          url: 'https://dx.doi.org/',
          entities:{
            "title": {
              js_element:$("#edit-title-0-value"),
              func: (response)=>response.title,
              value:null,
            },
            "container-title": {
              js_element:$("#edit-field-ercore-pb-journal-name-0-value"),
              func: (response)=>response.title,
              value:null,
            },
            "volume": {
              js_element:$("#edit-field-ercore-pb-journal-volume-0-value"),
              func: (response)=>response.volume,
              value:null,
            },
            "publisher": {
              js_element:$("#edit-field-ercore-pb-publisher-0-value"),
              func: (response)=>response.publisher,
              value:null,
            },
            "page": {
              js_element:$("#edit-field-ercore-pb-journal-pages-0-value"),
              func: (response)=>response.page,
              value:null,
            },
            "DOI": {
              js_element:$("#edit-field-ercore-pb-doi-0-value"),
              func: (response)=>response.DOI,
              value:null,
            },
            "type": {
              js_element:$("#edit-field-ercore-pb-type"),
              func: (response)=>response.type,
              value:null,
            },
            "published": {
              func: (response)=>{
                if (response.hasOwnProperty("published-print")) {
                  return response["published-print"]["date-parts"][0][0]
                } else {
                  return response["published-online"]["date-parts"][0][0]
                }
              },
              value:null,
            },
            
            "issue": {
              func: (response)=>{
                if (response.hasOwnProperty("issue")) {
                  return doiResponse["issue"]
                } else {
                  return null
                }
              },
              value:null,
            },
            
            "ISSN":{
              func: (response)=>{
                if (response.hasOwnProperty("ISSN")) {
                  return response.ISSN
                }
                else
                  return null
              },
              value:null,
            },
            "ISBN":{
              func: (response)=>{
                if (response.hasOwnProperty("ISBN")) {
                  return response.ISBN
                }
                else
                  return null
              },
              value:null,
            },
            "created": {
              func: (response)=>new Date(response["created"]["date-time"]),
              value:null,
            },
            "authors": {
              func: (response)=>{
                let authors = []
                let doi_auths = response.author
                for(let i = 0; i < doi_auths.length; i++){
                  authors.push(
                    {
                      'family_name':doi_auths[i]['family'],
                      'given_name':doi_auths[i]['given'] 
                    }
                  )
                }
                console.log("authors:", authors)
                return authors
              },
              value: null,
            }
          }
        },
        'DataCite': {
          url: 'https://api.datacite.org/dois/',
          entities:{
            "title": {
              js_element:$("#edit-title-0-value"),
              func: (response)=>response['data']['attributes']['titles'][0]['title'],
              value: null,
            },
            "container-title": {
              js_element:$("#edit-field-ercore-pb-journal-name-0-value"),
              func: (response)=>response['data']['attributes']['publisher'],
              value: null,
            },
            "volume": {
              js_element:$("#edit-field-ercore-pb-journal-volume-0-value"),
              func: (response)=>response['data']['attributes']['relatedItems']['volume'],
              value: null,
            },
            "publisher": {
              js_element:$("#edit-field-ercore-pb-publisher-0-value"),
              func: (response)=>response['data']['attributes']['relatedItems']['publisher'],
              value: null,
            },
            "page": {
              js_element:$("#edit-field-ercore-pb-journal-pages-0-value"),
              func: (response)=>{
                let related_items = response['data']['attributes']['relatedItems']
                if (related_items.hasOwnProperty('firstPage') && related_items.hasOwnProperty('lastPage')){
                  return related_items['firstPage']+"-"+related_items['lastPage']
                }
                else if(related_items.hasOwnProperty('firstPage') ){
                  return related_items['firstPage']
                }
                else if(related_items.hasOwnProperty('lastPage') ){
                  return related_items['lastPage']
                }
                else{
                  return null
                }
                
              },
              value: null,
            },
            "DOI": {
              js_element:$("#edit-field-ercore-pb-doi-0-value"),
              func: (response)=>response['data']['attributes']['doi'],
              value: null,
            },
            "type": {
              js_element:$("#edit-field-ercore-pb-type"),
              func: (response)=>response['data']['attributes']['types']['resourceType'] ? response['data']['attributes']['types']['resourceType'] : response['data']['attributes']['types']['resourceTypeGeneral'],
              value: null,
            },
            "published": {
              func: (response)=>response['data']['attributes']['published'],
              value:null,
            },
            "issue": {
              func: (response)=>response['data']['attributes']['relatedItems']['issue'],
              value:null,
            },
            "ISSN": {
              func: (response)=>{
                let idntfers = response['data']['attributes']['relatedIdentifiers']
                for(let i = 0; i<idntfers.length; i++){
                  if(idntfers[i]['relatedIdentifierType'] == 'ISSN'){
                    return idntfers[i]['relatedIdentifier']
                  }
                }
                return null
              },
              value:null,
            },
            "ISBN": {
              func: (response)=>{
                let idntfers = response['data']['attributes']['relatedIdentifiers']
                for(let i = 0; i<idntfers.length; i++){
                  if(idntfers[i]['relatedIdentifierType'] == 'ISBN'){
                    return idntfers[i]['relatedIdentifier']
                  }
                }
                return null
              },
              value:null,
            },
            "created": {
              func: (response)=>new Date(response['data']['attributes']["created"]),
              value:null,
            },
            "authors": {
              func: (response)=>{
                let authors = []
                let doi_auths = response['data']['attributes']['creators']
                for(let i = 0; i < doi_auths.length; i++){
                  authors.push(
                    {
                      'family_name':doi_auths[i]['familyName'],
                      'given_name':doi_auths[i]['givenName'] 
                    }
                  )
                }
                return authors
              },
              value: null,
            }
            // "abstract" : $("edit-body-0-value").val(response.abstract),//TODO
          }
        },
      }
      $.ajax({
        url: "https://dx.doi.org/doiRA/" + doi, dataType: "json",
        success: function (ra_response) {
          let doiRaResponse = ra_response;
          if ('status' in doiRaResponse[0]){
            console.log('NO DOI ENTERED')
            alert(doiRaResponse[0]['status'])
          }
          else{
            console.log(doiRaResponse[0]['RA'])
            let registry_agent = doiRaResponse[0]['RA']
            if(registry_agent in ra_map){
              $.ajax({
                url: ra_map[registry_agent]['url'] + doi, dataType: "json",
                success: function (response) {
                  let doiResponse = response;
                  doi_data = ra_map[registry_agent]['entities']

                  // // set the jquery entities from object  
                  // $.each(ra_map[registry_agent]['entities'], function (key, value) {
                  //   console.log(value)
                  //   if (ra_map[registry_agent] == 'Crossref' && response.hasOwnProperty(key) == true) {
                  //     if(key == 'type'){
                  //       console.log(value)
                  //       console.log(value['func'](response))
                  //       value['js_element'].val(typeMap[value['func'](response)])
                  //     }
                  //     else{
                  //       value['js_element'].val(value['func'](response))
                  //     }
                      
                  //     // console.log(value);
                  //     // value;
                  //   }
                  //   else{
                  //     value['js_element'].val(value['func'](response))
                  //   }
                  // });
                  // set the jquery entities from object  
                  $.each(ra_map[registry_agent]['entities'], function (key, value) {
                    console.log(value['func'](response))
                    if (value['func'](response) !== undefined) {
                      if(key == 'type'){
                        console.log(value)
                        console.log(value['func'](response))
                        value['js_element'].val(typeMap[value['func'](response)])
                        value['value'] = value['func'](response)
                      }
                      else if(value.hasOwnProperty("js_element")){
                        value['js_element'].val(value['func'](response))
                        value['value'] = value['func'](response)
                      }
                      else{
                        value['value'] = value['func'](response)
                      }
                      
                      // console.log(value);
                      // value;
                    }
                  });
                  console.log(response);
                  var strJSON = JSON.stringify(response);
                  $("#edit-field-doi-json-0-value").val(strJSON);
                  $("#edit-field-ercore-pb-status").val("0");
                  $("#edit-field-ercore-pb-date-wrapper").show();
                  $("#edit-field-ercore-pb-submit-date-wrapper").show();
                  $("#edit-field-ercore-nsf-wrapper").show();
                  $("#edit-field-ercore-pb-journal-name-wrapper").show();
                  $("#edit-field-ercore-pb-journal-volume-wrapper").show();
                  $("#edit-field-ercore-pb-publisher-wrapper").show();
                  $("#edit-field-ercore-pb-coll-title-wrapper").show();
                  $("#edit-field-ercore-pb-journal-pages-wrapper").show();
                  $("#edit-field-ercore-pb-doi-wrapper").show();
                  $("#edit-field-ercore-pb-issn-wrapper").show();
                  $("#edit-field-ercore-pb-ark-wrapper").show();
                  $("#edit-body-wrapper").show();
                  // $("#edit-body-0-value").show();
        
                  // $("#edit-field-ercore-pb-full-citation-0-value").val("EMPTY"); // TODO remove this
                  author_list = "";
                  citation_author_list = "";
                  let current_doi_authors = ra_map[registry_agent]['entities']['authors']['value']
                  console.log(current_doi_authors)
                  $.each(current_doi_authors, function (index, this_author) {
                    console.log(current_doi_authors.length);
                    if(index == current_doi_authors.length - 1 || current_doi_authors.length == 2){
                      citation_author_list += " & ";
                    } else if(index != current_doi_authors.length-1 && index != 0){
                      citation_author_list += ", ";
                    }
                    citation_author_list = citation_author_list + this_author["family_name"] + ", " + this_author['given_name'].charAt(0) + ".";
      
                  });
                  yearpub = ra_map[registry_agent]['entities']['published']['value']
                  // if (doiResponse.hasOwnProperty("published-print")) {
                  //   yearpub = doiResponse["published-print"]["date-parts"][0][0]
                  // } else {
                  //   yearpub = doiResponse["published-online"]["date-parts"][0][0]
                  // }
                  doi_title = ra_map[registry_agent]['entities']['title']['value'] 
                  doi_type = ra_map[registry_agent]['entities']['type']['value'] 
                  container_title = ra_map[registry_agent]['entities']['container-title']['value']
                  volume = ra_map[registry_agent]['entities']['volume']['value'] 
                  page = ra_map[registry_agent]['entities']['page']['value'] 
                  doi = ra_map[registry_agent]['entities']['DOI']['value'] 
                  citation_author_list = citation_author_list + " (" + yearpub + "). " + doi_title + ". ";
                  // if(doiResponse.type == "article-journal" || doiResponse.type == "journal-article" || doiResponse.type == "article-newspaper" || doiResponse.type == "article-magazine"){
                  if(doi_type == "Journal Article" || doi_type == "Magazine Article" || doi_type == "Newspaper Article"){
                    citation_author_list += container_title + ", " + volume + ", ";
                  }
                  if (page !== null) {
                    citation_author_list += doiResponse.page + ". ";
                  }
                  citation_author_list += "DOI: " + doi;
                  $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list);
        
                  function citation() { // TODO is this needed?
                    var citStr = "";
                    $.each(response.author, function (index, value) {
                      $.each(value, function (obj, val) {
                        if (obj == "given") {
                          citStr += val + ", ";
                        }
                        if (obj == "family") {
                          citStr += val.charAt(0);
                          if (val.charAt(-1) == ".") {
        
                          }
                        }
                      });
                    });
                  }
        
                  function issbn() {
                    count = 0;
                    if (ra_map[registry_agent]['entities']['ISSN']['value'] !== null) {
                      count += 1;
                    }
                    if (ra_map[registry_agent]['entities']['ISBN']['value'] !== null) {
                      count += 2;
                    }
                    return count;
                  }
                  switch (issbn()) {
                    case 0:
                      break;
                    case 1:
                      $("#edit-field-ercore-pb-issn-0-value").val(ra_map[registry_agent]['entities']['ISSN']['value'] );
                      break;
                    case 2:
                      $("#edit-field-ercore-pb-issn-0-value").val(ra_map[registry_agent]['entities']['ISBN']['value'] );
                      break;
                    case 3:
                      $("#edit-field-ercore-pb-issn-0-value").val(ra_map[registry_agent]['entities']['ISSN']['value']  + "/" + ra_map[registry_agent]['entities']['ISBN']['value'] );
                  }
        
                  pubdate = ra_map[registry_agent]['entities']['created']['value']
                  var pubdate_day = ('0' + pubdate.getDate()).slice(-2);
                  var pubdate_month = ('0' + (pubdate.getMonth() + 1)).slice(-2); //Months are zero based
                  var pubdate_year = pubdate.getFullYear();
                  pub_str = pubdate_year + "-" + pubdate_month + "-" + pubdate_day;
                  $("#edit-field-ercore-pb-date-0-value-date").val(pub_str);
                  $("#edit-field-ercore-pb-link-0-uri").val(response["URL"])
        
        
                  function hasDates() {
                    $("#edit-field-ercore-pb-status").val("0");
                    $("#edit-field-ercore-pb-date-wrapper").show();
                    $("#edit-field-ercore-pb-submit-date-wrapper").show();
                    $("#edit-field-ercore-nsf-wrapper").show();
                    if (response.hasOwnProperty("published-print") && response.hasOwnProperty("published-online")) {
                      return "both";
                    }
                    else if (response.hasOwnProperty("published-print")) {
                      return "print";
                    }
                    else if (response.hasOwnProperty("published-online")) {
                      return "online"
                    }
                    else {
                      return null;
                    }
                  }
        
                  var pubType = ["published-online", "published-print"];
                  pubMap = {
                    "published-online": {
                      "obj": null,
                      "str": ""
                    },
                    "published-print": {
                      "obj": null,
                      "str": ""
                    }
                  }
        
                }
              });
            }
            else{
              alert('Registry Agent ('+registry_agent+') not in Registry Agency map.\n Please ask adminsitrators to add this Registry Agency')
            }
          }
        },
      }).fail(function() {
        alert('ERROR in DOI ajax call');
      }); 
      

    }, false);
    // add change listenter to citation format list
    var citeFormatList = document.getElementById('edit-field-citation-format');


    citeFormatList.addEventListener('change', function(){
      console.log($('#edit-field-citation-format').val());
      // var selectedVal = $(this).find(':selected').val(); //alternate way of getting same result as selection = $('#edit-field-citation-format').val();
      // var selectedText = $(this).find(':selected').text();
      selection = $('#edit-field-citation-format').val();
      console.log(selection)
      var citation = "";
      if(doiResponse != null || $("#edit-field-doi-json-0-value").val() != ""){
        if($("#edit-field-doi-json-0-value").val() != ""){
          console.log($("#edit-field-doi-json-0-value").val());
          var objJSON = JSON.parse($("#edit-field-doi-json-0-value").val());
          doiResponse = objJSON;
        }
        switch (selection){
          case '_none':
            $("#edit-field-ercore-pb-full-citation-0-value").val("");
            break;
          case 'APA':
            author_list = "";
            citation_author_list = "";
            var current_doi_authors = doi_data['authors']['value']
            console.log(current_doi_authors)
            $.each(current_doi_authors, function (index, this_author) {
              console.log(current_doi_authors.length);
              if(index == current_doi_authors.length - 1 || current_doi_authors.length == 2){
                citation_author_list += " & ";
              } else if(index != current_doi_authors.length-1 && index != 0){
                citation_author_list += ", ";
              }
              citation_author_list = citation_author_list + this_author["family_name"] + ", " + this_author['given_name'].charAt(0) + ".";

            });
            yearpub = doi_data['published']['value']
            // if (doiResponse.hasOwnProperty("published-print")) {
            //   yearpub = doiResponse["published-print"]["date-parts"][0][0]
            // } else {
            //   yearpub = doiResponse["published-online"]["date-parts"][0][0]
            // }
            doi_title = doi_data['title']['value'] 
            doi_type = doi_data['type']['value'] 
            container_title = doi_data['container-title']['value']
            volume = doi_data['volume']['value'] 
            page = doi_data['page']['value'] 
            doi = doi_data['DOI']['value'] 
            citation_author_list = citation_author_list + " (" + yearpub + "). " + doi_title + ". ";
            // if(doiResponse.type == "article-journal" || doiResponse.type == "journal-article" || doiResponse.type == "article-newspaper" || doiResponse.type == "article-magazine"){
            if(doi_type == "Journal Article" || doi_type == "Magazine Article" || doi_type == "Newspaper Article"){
              citation_author_list += container_title + ", " + volume + ", ";
            }
            if (page !== null) {
              citation_author_list += doiResponse.page + ". ";
            }
            citation_author_list += "DOI: " + doi;
            $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list);
            break;
          case 'Chicago':
            //Authors List
            author_list = ""
            citation_author_list = ""
            var current_doi_authors = doi_data['authors']['value']
            $.each(current_doi_authors, function (index, this_author) { //TODO
              citation_author_list = citation_author_list + this_author['given_name'] + " " + this_author['family_name'] + ", "

              // if (this_author['sequence'] == "first") {
              //   citation_author_list = citation_author_list + this_author['family_name'] + ", " + this_author['given_name']
              // } else {
              //   citation_author_list = citation_author_list + this_author['given_name'] + " " + this_author['family_name']
              // }
            });
            // yearpub = ""
            // if (doiResponse.hasOwnProperty("published-print")) {
            //   yearpub = doiResponse["published-print"]["date-parts"][0][0]
            // } else {
            //   yearpub = doiResponse["published-online"]["date-parts"][0][0]
            // }
            yearpub = doi_data['published']['value']
            doi_title = doi_data['title']['value'] 
            doi_type = doi_data['type']['value'] 
            container_title = doi_data['container-title']['value']
            volume = doi_data['volume']['value'] 
            doi_page = doi_data['page']['value'] 
            doi = doi_data['DOI']['value'] 
            doi_issue = doi_data['issue']['value'] 
            doi_publisher = doi_data['publisher']['value'] 
            page = ""
            if (doi_page !== null) {
              page = ", p" + doi_page
            }
            citation_author_list += " " + yearpub + ". \"" + doi_title + ".\" " + container_title + " " + volume + "(" + doi_issue + ")" + doi_page + ". " + doi_publisher + ". doi:" + doi

            $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list);
            break;
        }
          $.each(doiResponse.author, function (index, this_author) {
            console.log(this_author);
          });
      }
    });
  }(jQuery))
};